
#ifndef _ANALOG_													//    
#define _ANALOG_

#include <avr/iom128.h>												//  /

#define AIN0    0													// "1  "
#define AIN1    1													// "2  "
#define AIN2    2													// "3  "
#define AIN3    3													// "4  "

#define VOLTAGE 0													// "   0-2.5 "
#define CURRENT 1													// "   0-20 "

static char _Range=0;												//  

//==========================     ===========================
//    :
//channel -   ( 0  3)
//Range -   
// :
//0-  , 1 -    

char ADC_Start_Measuring(char Channel, char Range)
{
	if ((Channel>3) || (Range>1)) return 0xFF;						//    ,   
	
	_Range=Range;
	
	ADMUX=Channel | 0xC0;											//        2.56
	ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);	//  ,  ,    128

	return 0;
}

//============================      ==============================
// :
//*Data -        (     )
// :
//0 -   , 1 -    

char ADC_Read(unsigned int *Data)
{
	if ((ADCSRA & (1<<ADIF))!=0)									//    
	{
		ADCSRA|=(1<<ADIF);											//   
		if (_Range==0) *Data=(float)ADC*2.5+0.5;
		else *Data=(float)ADC*2500/124+0.5;
		return	0;													//  
	}
	else return 1;													//    
}
#endif