#ifndef _KEY_														//    
#define _KEY_

#ifdef _KEY_NO
#warning "In this device of the button is absent"
#else

#include <avr/iom128.h>												//  /


#define UP   0														// " "
#define DOWN 1														// " "
#define LATCH_ON 1													// " "
#define LATCH_OFF 0													// " "

#include "Timer2.h"													//    2

//=============================    ===============================
//    :
//key -  
//sw  -      (0- /1- )
// :
//0x00-        ,    0xFF

void Key_Init(char sw)
{
	DDRA&=0xF0;														//    
	PORTA|=0x0F;													//  
	
	_Latch=sw;														///    
	_Key_flags=0;													//   

#ifdef TIMER2	
	if (sw==1) _Timer2_Enable();									//    2
	sei();															//  	
#endif
}

//===========================     ==============================
//    :
//key -  
// :
//  (0x01- /0x00-  )

char Key(char key)
{
	char temp;														// 	
	
	if (_Latch==0)
	{
		switch (key)
		{
		case 0: return ((PINA & (1<<PA3)) >> PA3) ^ 0x01;
		case 1: return ((PINA & (1<<PA2)) >> PA2) ^ 0x01;
		case 2: return ((PINA & (1<<PA1)) >> PA1) ^ 0x01;
		case 3: return ((PINA & (1<<PA0)) >> PA0) ^ 0x01;		
		default: return 0xFF;
		}
	}
	else 
	{
		temp=(_Key_flags>>key) & 0x01;								//  
		_Key_flags&=~(0x01<<key);									//    
		return temp;
	}
}
#endif
#endif
